This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 848551 - Review Request: prepaid-manager-applet - An applet for the GNOME Desktop for GSM mobile prepaid SIM cards
Review Request: prepaid-manager-applet - An applet for the GNOME Desktop for ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
17
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
: 691635 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-15 17:03 EDT by Kai Engert (:kaie)
Modified: 2012-09-27 00:32 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-30 06:58:28 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Kai Engert (:kaie) 2012-08-15 17:03:15 EDT
Spec URL: http://kuix.de/fedora/ppm/prepaid-manager-applet.spec
SRPM URL: http://kuix.de/fedora/ppm/prepaid-manager-applet-0.0.3.1-1.fc16.src.rpm
Description: 
prepaid-manager-applet aims to ease the handling of mobile internet
connections using GSM mobile prepaid cards on the GNOME Desktop.
Such a SIM card can either be in a mobile phone used as a modem,
a usb 3g module (usb surf stick) or used by the built in 3G
chip set in your laptop/net book.

* It allows you to check the current balance and to top up the credit.
* It uses ModemManager to talk to your GSM chip set.
Comment 1 Kai Engert (:kaie) 2012-08-15 17:03:41 EDT
*** Bug 691635 has been marked as a duplicate of this bug. ***
Comment 2 Mario Blättermann 2012-08-17 15:22:31 EDT
Scratch build fails for f17 and f18:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4400046
http://koji.fedoraproject.org/koji/taskinfo?taskID=4400294

From build.log:

> configure: error: Package requirements (glib-2.0 >= 2.25.6
>                         gtk+-3.0 >= 3.0.0
>                         pygobject-3.0 >= 3.0) were not met:
> No package 'pygobject-3.0' found

You have to replace all occurences of pygobject2 with pygobject3 in BuildRequires and Requires. Moreover, you can drop the following from BuildRequires:

gettext: needed by intltool

python2-devel: obsolete, has to be python3-devel actually, but it is not needed because the Python build stack (setup.py etc.) is not used here, the package uses autotools

glib2-devel: needed by Gtk anyway, the v2 is obsolete for the newest sources


There are a lot of entries in Requires. You should build your package without them and check what is picked up automatically. Then add those which are not found by rpm.

The initial cleaning of %{buildroot} in the %install section and the %defattr line in %files are obsolete. Please drop them unless you would want to provide your package for EPEL 5 (which is impossible due to unresolvable dependencies).


Some files are installed in %{_datadir}/icons/hicolor/, you have to add the following scripts to update the icon cache:

%post
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


To install the desktop file correctly, you have to add desktop-file-utils to BuildRequires.

And last but not least: Please don't forget to log your changes in the Changelog!
Comment 3 Kai Engert (:kaie) 2012-08-20 11:37:33 EDT
> You have to replace all occurences of pygobject2 with pygobject3 in
> BuildRequires and Requires. 

done


> Moreover, you can drop the following from BuildRequires:
> gettext: needed by intltool

ok


> python2-devel: obsolete, has to be python3-devel actually, but it is not
> needed because the Python build stack (setup.py etc.) is not used here, the
> package uses autotools

removed


> glib2-devel: needed by Gtk anyway, the v2 is obsolete for the newest sources

removed


> There are a lot of entries in Requires. You should build your package
> without them and check what is picked up automatically. Then add those which
> are not found by rpm.

We had:

Requires:       mobile-broadband-provider-info ModemManager gtk3 
Requires:       dbus-python pygobject3 gtk3

I'm surprised you call that "a lot".
I removed the duplicate gtk3.
Why is it a problem to list requirements explicity?

I'll try to run the try-and-error experiments you've asked for, if they're not requiring too much time.


> The initial cleaning of %{buildroot} in the %install section and the
> %defattr line in %files are obsolete. Please drop them

removed


> Some files are installed in %{_datadir}/icons/hicolor/, you have to add the
> following scripts to update the icon cache:

added

> To install the desktop file correctly, you have to add desktop-file-utils to
> BuildRequires.

It was already there.


> And last but not least: Please don't forget to log your changes in the
> Changelog!

will do
Comment 4 Kai Engert (:kaie) 2012-08-20 13:07:21 EDT
> There are a lot of entries in Requires. You should build your package
> without them and check what is picked up automatically. Then add those which
> are not found by rpm.

I did that and ran a scratch build, and the requires list for that build is:

$ rpm -qp --requires prepaid-manager-applet-0.0.3.1-2.fc17.noarch.rpm 
/bin/sh  
/bin/sh  
/bin/sh  
/bin/sh  
/usr/bin/python  
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PartialHardlinkSets) <= 4.0.4-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(PayloadIsXz) <= 5.2-1
Comment 7 Mario Blättermann 2012-08-20 14:03:28 EDT
(In reply to comment #3) 
> Requires:       mobile-broadband-provider-info ModemManager gtk3 
> Requires:       dbus-python pygobject3 gtk3
> 
> I'm surprised you call that "a lot".
> I removed the duplicate gtk3.
> Why is it a problem to list requirements explicity?

Usually there's almost nothing in "Requires" because most of the requirements will be picked up automatically while building the package. Exceptions are modules of Python, Perl and similar scripting languages and some other cases. Packages which use Autotools don't need adding runtime requirements in most cases, and according to the packaging guidelines you must not add them manually if there's another way to pick them up.

(In reply to comment #4)
> I did that and ran a scratch build, and the requires list for that build is:
> 
> $ rpm -qp --requires prepaid-manager-applet-0.0.3.1-2.fc17.noarch.rpm 
> /bin/sh  
> /bin/sh  
> /bin/sh  
> /bin/sh  
> /usr/bin/python  
> rpmlib(CompressedFileNames) <= 3.0.4-1
> rpmlib(FileDigests) <= 4.6.0-1
> rpmlib(PartialHardlinkSets) <= 4.0.4-1
> rpmlib(PayloadFilesHavePrefix) <= 4.0-1
> rpmlib(PayloadIsXz) <= 5.2-1

OK, in this case you can keep all the requirements excepting the duplicate of gtk3.

I will do a formal review soon.
Comment 8 Mario Blättermann 2012-08-23 06:50:28 EDT
New scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4416747

$ rpmlint -i -v *
prepaid-manager-applet.src: I: checking
prepaid-manager-applet.src: I: checking-url https://honk.sigxcpu.org/piki/projects/ppm/ (timeout 10 seconds)
prepaid-manager-applet.src: I: checking-url http://honk.sigxcpu.org/projects/ppm/tarballs/prepaid-manager-applet-0.0.3.1.tar.xz (timeout 10 seconds)
prepaid-manager-applet.noarch: I: checking
prepaid-manager-applet.noarch: I: checking-url https://honk.sigxcpu.org/piki/projects/ppm/ (timeout 10 seconds)
prepaid-manager-applet.noarch: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/accountdb.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/provider.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/providerdb.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/prepaid-manager-applet.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/modemproxy.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: W: no-manual-page-for-binary prepaid-manager-applet
Each executable in standard binary directories should have a man page.

2 packages and 0 specfiles checked; 5 errors, 2 warnings.


Wrong FSF addresses and missing man pages, no real problems.


But still some recognizable issues:

Add the following line to %files:
%doc AUTHORS COPYING NEWS README TODO

Change the license to GPLv3+ according to some file headers in the source tarball.

Don't forget to track your changes in the %changelog, as already mentioned.
Comment 9 Kai Engert (:kaie) 2012-08-28 13:13:48 EDT
> Wrong FSF addresses and missing man pages, no real problems.

I've mailed the upstream maintainer and asked to get the FSF license headers updated in a future release.


> Add the following line to %files:
> %doc AUTHORS COPYING NEWS README TODO

I believe it's not as simple as you think,
because the upstream installation scripts don't install these files into the area that will be used as the base for packaging.

I added copy commands to %install that copy those files to %{_docdir}/%{name}/
and added appropriate entries to %files


> Change the license to GPLv3+ according to some file headers in the source
> tarball.

Ok.


> Don't forget to track your changes in the %changelog, as already mentioned.

ok


Updated:

Spec URL: http://kuix.de/fedora/ppm/prepaid-manager-applet.spec
SRPM URL: http://kuix.de/fedora/ppm/prepaid-manager-applet-0.0.3.1-4.fc17.src.rpm
Comment 10 Mario Blättermann 2012-08-28 14:05:24 EDT
(In reply to comment #9)
> > Add the following line to %files:
> > %doc AUTHORS COPYING NEWS README TODO
> 
> I believe it's not as simple as you think,
> because the upstream installation scripts don't install these files into the
> area that will be used as the base for packaging.
> 
> I added copy commands to %install that copy those files to
> %{_docdir}/%{name}/
> and added appropriate entries to %files
> 
Not needed at all. If you use that line as is, the %doc macro picks up the appropriate files and puts them into the right folder automatically. In case of that the install script from the tarball puts them anywhere else, just use the %exclude macro in the file list to avoid installing duplicates.
Comment 11 Kai Engert (:kaie) 2012-08-28 14:35:07 EDT
> %doc AUTHORS COPYING NEWS README TODO

I probably made a mistake in my earlier testing,
I confirm it works now.

Spec URL: http://kuix.de/fedora/ppm/prepaid-manager-applet.spec
SRPM URL: http://kuix.de/fedora/ppm/prepaid-manager-applet-0.0.3.1-5.fc17.src.rpm
Comment 12 Mario Blättermann 2012-08-28 16:00:01 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4432324

$ rpmlint -i -v *
prepaid-manager-applet.src: I: checking
prepaid-manager-applet.src: I: checking-url https://honk.sigxcpu.org/piki/projects/ppm/ (timeout 10 seconds)
prepaid-manager-applet.src: I: checking-url http://honk.sigxcpu.org/projects/ppm/tarballs/prepaid-manager-applet-0.0.3.1.tar.xz (timeout 10 seconds)
prepaid-manager-applet.noarch: I: checking
prepaid-manager-applet.noarch: I: checking-url https://honk.sigxcpu.org/piki/projects/ppm/ (timeout 10 seconds)
prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/accountdb.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/provider.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/providerdb.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/ppm/modemproxy.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: E: incorrect-fsf-address /usr/share/prepaid-manager-applet/prepaid-manager-applet.py
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

prepaid-manager-applet.noarch: W: no-manual-page-for-binary prepaid-manager-applet
Each executable in standard binary directories should have a man page.

prepaid-manager-applet.spec: I: checking-url http://honk.sigxcpu.org/projects/ppm/tarballs/prepaid-manager-applet-0.0.3.1.tar.xz (timeout 10 seconds)
2 packages and 1 specfiles checked; 5 errors, 1 warnings.


No real issues. The wrong FSF addresses have been discussed earlier, and no man page is no review blocker.



---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    GPLv3+
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    76b2a5668f419dbfe889d84b54deb18d536c1b5c1f2d3970ca687290f1048f66  prepaid-manager-applet-0.0.3.1.tar.xz
    76b2a5668f419dbfe889d84b54deb18d536c1b5c1f2d3970ca687290f1048f66  prepaid-manager-applet-0.0.3.1.tar.xz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[+] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[.] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: Development files must be in a -devel package.
[.] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[.] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

----------------

PACKAGE APPROVED

----------------
Comment 13 Kai Engert (:kaie) 2012-08-29 15:32:34 EDT
New Package SCM Request
=======================
Package Name: prepaid-manager-applet
Short Description: An applet for the GNOME Desktop for GSM mobile prepaid SIM cards
Owners: kengert ankursinha
Branches: f17 f18
InitialCC:
Comment 14 Gwyn Ciesla 2012-08-29 17:08:21 EDT
Git done (by process-git-requests).

Mario, please take ownership of review BZs, thanks!
Comment 15 Fedora Update System 2012-08-30 06:57:30 EDT
prepaid-manager-applet-0.0.3.1-5.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/prepaid-manager-applet-0.0.3.1-5.fc17
Comment 16 Fedora Update System 2012-08-30 06:57:41 EDT
prepaid-manager-applet-0.0.3.1-5.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/prepaid-manager-applet-0.0.3.1-5.fc18
Comment 17 Kai Engert (:kaie) 2012-08-30 06:58:28 EDT
Ankur Sinha, you have full rights for the package, thanks a lot for your initial work.

Mario, thanks a lot for your help with the package review.

Jon, thanks for creating the package in git, I confirm things work well!

f17
http://koji.fedoraproject.org/koji/taskinfo?taskID=4437248

f18
http://koji.fedoraproject.org/koji/taskinfo?taskID=4437240

Closing.
Comment 18 Kai Engert (:kaie) 2012-08-31 14:36:44 EDT
It would be great if people interested in this package could please get the package, and...

please give karma. That's necessary to get the package pushed to the stable update area. See the links in comment 15 and 16. Thanks!
Comment 19 Fedora Update System 2012-09-18 09:11:45 EDT
prepaid-manager-applet-0.0.3.1-6.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/prepaid-manager-applet-0.0.3.1-6.fc17
Comment 20 Fedora Update System 2012-09-18 09:12:05 EDT
prepaid-manager-applet-0.0.3.1-6.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/prepaid-manager-applet-0.0.3.1-6.fc18
Comment 21 Fedora Update System 2012-09-20 16:37:46 EDT
prepaid-manager-applet-0.0.3.1-6.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 22 Fedora Update System 2012-09-27 00:32:21 EDT
prepaid-manager-applet-0.0.3.1-6.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.